--
-- Mod: Animals Hud
--
-- Author: Deekay
-- email: domkopp29@gmail.com
-- @Date: 17.12.2018
-- @Version: 2.0.0.0 

animalsHUD = {};

local modDesc = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml");

animalsChickenHudActive = false;
animalsCowHudActive = false;
animalsHorseHudActive = false;
animalsPigHudActive = false;
animalsSheepHudActive = false;

showDebug = false;

fontSize = 0.011;
fontSizeChange = 0.001;

animalsHUD.version = getXMLString(modDesc, "modDesc.version");
animalsHUD.modDirectory = g_currentModDirectory;

addModEventListener(animalsHUD);

function animalsHUD:loadMap()

	print("############################################################");
	print("--- Animals HUD v.:" .. self.version .. ", by Deekay.");
	print("############################################################");

	end;

function animalsHUD:keyEvent(unicode, sym, modifier, isDown)
  
  	--SHOW HUD CHICKEN
	 if Input.isKeyPressed(Input.KEY_lalt) and Input.isKeyPressed(Input.KEY_t) then
		animalsChickenHudActive =not animalsChickenHudActive;
	end;
  	--SHOW HUD COW
	 if Input.isKeyPressed(Input.KEY_lalt) and Input.isKeyPressed(Input.KEY_y) then -- Warning Z & Y changes English German Keyboard
		animalsCowHudActive =not animalsCowHudActive;
	end;
  	--SHOW HUD PIG
	 if Input.isKeyPressed(Input.KEY_lalt) and Input.isKeyPressed(Input.KEY_u) then
		animalsPigHudActive =not animalsPigHudActive;
	end;
  
  	--SHOW HUD HORSE
	 if Input.isKeyPressed(Input.KEY_lalt) and Input.isKeyPressed(Input.KEY_i) then
		animalsHorseHudActive =not animalsHorseHudActive;
	end;
   
  	--SHOW HUD SHEEP
	 if Input.isKeyPressed(Input.KEY_lalt) and Input.isKeyPressed(Input.KEY_o) then
		animalsSheepHudActive =not animalsSheepHudActive;
	end;
  
  --Correct Font Size --
	 if Input.isKeyPressed(Input.KEY_lalt) and Input.isKeyPressed(Input.KEY_9) then
     fontSize = fontSize - fontSizeChange
	end;
  
  --Correct Font Size ++
	 if Input.isKeyPressed(Input.KEY_lalt) and Input.isKeyPressed(Input.KEY_0) then
     fontSize = fontSize + fontSizeChange
	end;
  
  
end;

function animalsHUD:mouseEvent(posX, posY, isDown, isUp, button)
end;

function animalsHUD:deleteMap()
end;

function animalsHUD:update(dt)

end;

function animalsHUD:draw()
  
  
           -- ID 28 = GRAS
           -- ID 24 = SILAGE 
           -- ID 30 = HEU
           -- ID 19 = MISCHRATION
           -- ID 18 = WASSER
           -- ID 31 = STROH
           -- ID 2 = WEIZEN
           -- ID 8 = MAIS
           -- ID 6 = SONNENBLUMEN
           -- ID 9 = KARTOFFEL
           -- ID 4 = HAFER
           -- ID 10 = ZUCKERRÜBEN
           -- ID 3 = GERSTE
           -- ID 7 = SOYABOHNEN
           -- ID 5 = RAPS

    
      -------------------------------------------------
      -- setting for screen render
      -------------------------------------------------
		 posX = 0.83;
		 posX2 = posX + 0.15;
		 posY = 0.85; 
		 linePadding = 0.003;
		 paddingBetweenLines = fontSize + 0.004;
		 setTextColor(1,1,1,1);
     
       --check percent and set colors
   function setColorIndicatorForMaxAndMinPercentValues(percent)
     
     setColorWhite(); -- set all text to white
     
     if percent ~= nil then
      if percent >= 75 then
        setTextColor(0,1,0,1); -- green
        return percent
        
      elseif percent >= 45 then
        setTextColor(0,1,1,1); -- blue
        return percent
        
      elseif percent >= 15 then
        setTextColor(1,1,0,1); -- orange
        return percent
        
      elseif percent < 15 then
      setTextColor(1,0,0,1); -- red
       return percent
       
     end
    end
  end
  
  function setCleanLinessColorIndicatorForMaxAndMinPercentValues(percent)
    
     setColorWhite(); -- set all text to white
     
      if percent >= 95 then
        setTextColor(0,1,0,1); -- green
        return percent, tostring("OK, Sauber! :)")
        
      elseif percent >= 60 then
        setTextColor(0,1,1,1); -- blue
        return percent, tostring("Toll! Es wird!")
        
      elseif percent >= 30 then
        setTextColor(1,1,0,1); -- orange
        return percent, tostring("Es könnte besser sein!")
        
      elseif percent < 30 then
      setTextColor(1,0,0,1); -- red
       return percent, tostring("NOK, Dreckig :(")
      
   end
    
  end

     
     
    -------------------------------------------------
    -- draw the animals infos on the screen. 
    -------------------------------------------------
    function drawInfo(title, firstValueToDraw, secondValueToDraw, valueForPadding)
      
    setTextAlignment(RenderText.ALIGN_LEFT);
    setTextBold(false);
    posY = posY - paddingBetweenLines;
    
    if title~=nil and firstValueToDraw ~=nil  then
      if valueForPadding == 0 then
         setColorWhite()
        setTextAlignment(RenderText.ALIGN_LEFT);    
        renderText(posX, posY, fontSize, title) -- first item -- RENDER THE TITLE EXAMPLE "WHEAT:"
        setTextAlignment(RenderText.ALIGN_RIGHT);
        
        -- CHECK IF A ANIMAL OR FRUIT
        -- NUMBER = FRUIT
        if secondValueToDraw ~= "" then
          if title == "Sauberkeit:" then
           local _,warningMessageWithColor = setCleanLinessColorIndicatorForMaxAndMinPercentValues(firstValueToDraw)
           
            renderText(posX2, posY, fontSize, "" .. tostring(firstValueToDraw).."%" .. " " .. tostring(warningMessageWithColor))  --RENDER THE VALUES EXAMPLE "5000L: 50%"
          else
            local secondValueWithColorWarning = setColorIndicatorForMaxAndMinPercentValues(secondValueToDraw)
            renderText(posX2, posY, fontSize, "" .. tostring(firstValueToDraw).."L" .. " " .. tostring(secondValueWithColorWarning).."% Voll")  --RENDER THE VALUES EXAMPLE "5000L: 50%"
        end
      else
        setColorWhite()
        renderText(posX2, posY, fontSize, "" .. tostring(firstValueToDraw))  -- only for animals count render
         end
  end
  
  if valueForPadding > 0  then
      setColorWhite()
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(posX, posY, fontSize, title) -- all other items -- RENDER THE TITLE EXAMPLE "WHEAT:"
      setTextAlignment(RenderText.ALIGN_RIGHT);
      
        -- CHECK IF A ANIMAL OR FRUIT
        -- NUMBER = FRUIT
       if secondValueToDraw ~= "" then
          if title == "Sauberkeit:" then
        
           local _,warningMessageWithColor = setCleanLinessColorIndicatorForMaxAndMinPercentValues(firstValueToDraw)
           
            renderText(posX2, posY, fontSize, "" .. tostring(firstValueToDraw).."%" .. " " .. tostring(warningMessageWithColor))  --RENDER THE VALUES EXAMPLE "5000L: 50%"
          else
            local secondValueWithColorWarning = setColorIndicatorForMaxAndMinPercentValues(secondValueToDraw)
            renderText(posX2, posY, fontSize, "" .. tostring(firstValueToDraw).."L" .. " " .. tostring(secondValueWithColorWarning).."% Voll")  --RENDER THE VALUES EXAMPLE "5000L: 50%"
        end
      else
        setColorWhite()
         renderText(posX2, posY, fontSize, "" .. tostring(firstValueToDraw))  -- only for animals count render 
  end;
  else
    print("drawinfo function nil")
    end
   end
   end
   
   function setColorWhite()
    setTextColor(1,1,1,1);
end

    -------------------------------------------------
    -- creates a padding freespace
    -------------------------------------------------
		function paddingTop()
			posY = posY - linePadding;
		end;
    
       function getFillLevelFoodFromId(id, husbandry)
         
         if id ~=nil and husbandry ~=nil then 
         
          --loop for fillCapacity Food
           local capacities = husbandry.modulesByName.food.foodGroupCapacities
           local capacity = 0;
           for k,v in pairs(capacities) do  
             capacity = capacities[k].capacity;
           end
             local fillLevelFood = tonumber(math.ceil(husbandry.modulesByName.food.fillLevels[id]));
             local fillLevelFoodPercent = tonumber(math.ceil((100 * fillLevelFood / capacity)));
            return fillLevelFood , fillLevelFoodPercent;
          else
            print("Fehler mit ID (".. id ..") und husbandry (".. husbandry .. ")")
          end
        end
        
           function getFillLevelWaterFromId(id, husbandry)
             if id ~=nil and husbandry ~=nil then 
             --loop for fillCapacity Water
            local capacity = husbandry.modulesByName.water.fillCapacity
             local fillLevelWater = tonumber(math.ceil(husbandry.modulesByName.water.fillLevels[id]));
             local fillLevelWaterPercent = tonumber(math.ceil((100 * fillLevelWater / capacity)));
             return fillLevelWater , fillLevelWaterPercent;
             else
            print("Fehler mit ID (".. id ..") und husbandry (".. husbandry .. ")")
          end
        end

          function getFillLevelStrawFromId(id, husbandry)
            if id ~=nil and husbandry ~=nil then 
             --loop for fillCapacity Straw
             local capacity = husbandry.modulesByName.straw.fillCapacity
             local fillLevelStraw = tonumber(math.ceil(husbandry.modulesByName.straw.fillLevels[id]));
             local fillLevelStrawPercent = tonumber(math.ceil((100 * fillLevelStraw / capacity)));
            
            return fillLevelStraw, fillLevelStrawPercent;
            else
            print("Fehler mit ID (".. id ..") und husbandry (".. husbandry .. ")")
          end
          end
          
          function getCleanlinessFactorInPercent(husbandry)
            local cleanPercent = tonumber(math.ceil(husbandry.modulesByName.foodSpillage.cleanlinessFactor * 100)) --%
            return cleanPercent
          end
          
          function countAnimals(husbandry)
            local numberOfAnimalsChicken = 0;
            for k,v in pairs(husbandry.modulesByName.animals.animals) do
          numberOfAnimalsChicken = tonumber(k)
        end
            return numberOfAnimalsChicken
          end 
          
	if animalsChickenHudActive == true then --CHICKEN
   for _,husbandry in pairs(g_currentMission.husbandries) do
			if husbandry.modulesByName.animals.animalType == "CHICKEN" then
        local numberOfAnimals = countAnimals(husbandry);
        
         if numberOfAnimals > 0 then
           
           local cleanliness = getCleanlinessFactorInPercent(husbandry);
           local cleanlinessPercent,cleanlinessText  = setCleanLinessColorIndicatorForMaxAndMinPercentValues(cleanliness)
           
           
           local weizenFillLevel,weizenFillLevelPercent  = getFillLevelFoodFromId(2,husbandry)
           local gersteFillLevel,gersteFillLevelPercent  = getFillLevelFoodFromId(3, husbandry)
           
          drawInfo("Hühner im Stall:" , numberOfAnimals,"",                     tonumber(linePadding));  
          drawInfo("Sauberkeit:"      , cleanlinessPercent   ,cleanlinessText, tonumber(linePadding)); 
          drawInfo("Weizen:"          , weizenFillLevel,weizenFillLevelPercent ,tonumber(linePadding));
          drawInfo("Gerste:"          , gersteFillLevel,gersteFillLevelPercent ,tonumber(linePadding));
     
          drawInfo("-KEY T-------------------------------------------------","","", tonumber(linePadding))
        else 
        
          drawInfo("Keine Hühner im Stall, kaufe welche","","", tonumber(linePadding))
          drawInfo("-KEY T-------------------------------------------------","","", tonumber(linePadding))
           end;
         end;
      paddingTop();
 end
end

if animalsCowHudActive == true then -- COW
      for _,husbandry in pairs(g_currentMission.husbandries) do
			if husbandry.modulesByName.animals.animalType == "COW" then
     local numberOfAnimals = countAnimals(husbandry);
         if numberOfAnimals > 0 then
           
           local cleanliness = getCleanlinessFactorInPercent(husbandry);
           local cleanlinessPercent,cleanlinessText  = setCleanLinessColorIndicatorForMaxAndMinPercentValues(cleanliness)
           
           local waterFillLevel,waterFillLevelPercent             = getFillLevelWaterFromId(18,husbandry)
           local strawFillLevel,strawFillLevelPercent             = getFillLevelStrawFromId(31,husbandry)
           local grassFillLevel,grassFillLevelPercent             = getFillLevelFoodFromId(28,husbandry)
           local mischrationFillLevel,mischrationFillLevelPercent = getFillLevelFoodFromId(19,husbandry)
           local heuFillLevel,heuFillLevelPercent                 = getFillLevelFoodFromId(30,husbandry)
           local silageFillLevel,silageFillLevelPercent           = getFillLevelFoodFromId(24, husbandry)
           
           drawInfo("Kühe im Stall:", numberOfAnimals,"",                                 tonumber(linePadding));  
           drawInfo("Sauberkeit:"      , cleanlinessPercent    ,cleanlinessText, tonumber(linePadding)); 
           drawInfo("Wasser:"       , waterFillLevel,       waterFillLevelPercent,        tonumber(linePadding));
           drawInfo("Stroh:"        , strawFillLevel,       strawFillLevelPercent,        tonumber(linePadding));
           drawInfo("Gras:"         , grassFillLevel,       grassFillLevelPercent ,       tonumber(linePadding));
           drawInfo("Mischration:"  , mischrationFillLevel, mischrationFillLevelPercent,  tonumber(linePadding));
           drawInfo("Heu:"          , heuFillLevel,         heuFillLevelPercent,          tonumber(linePadding));
           drawInfo("Silage:"       , silageFillLevel,      silageFillLevelPercent,       tonumber(linePadding));
         
           drawInfo("-KEY Z-------------------------------------------------","","", tonumber(linePadding))
         else 
        
          drawInfo("Keine Kühe im Stall, kaufe welche","","", tonumber(linePadding))
          drawInfo("-KEY Z-------------------------------------------------","","", tonumber(linePadding))
           end;
         end;
      paddingTop();
    end;
  end;
  
  if animalsPigHudActive == true then -- PIG
      for _,husbandry in pairs(g_currentMission.husbandries) do
			if husbandry.modulesByName.animals.animalType == "PIG" then
    
        local numberOfAnimals = countAnimals(husbandry);

         if numberOfAnimals > 0 then
           
           local cleanliness = getCleanlinessFactorInPercent(husbandry);
           local cleanlinessPercent,cleanlinessText  = setCleanLinessColorIndicatorForMaxAndMinPercentValues(cleanliness)
           
           local waterFillLevel,waterFillLevelPercent                 = getFillLevelWaterFromId(18,husbandry)
           local strawFillLevel,strawFillLevelPercent                 = getFillLevelStrawFromId(31,husbandry)
           
           local maisFillLevel,maisFillLevelPercent                   = getFillLevelFoodFromId(8,husbandry)
           local weizenFillLevel,weizenFillLevelPercent               = getFillLevelFoodFromId(2,husbandry)
           
           local gersteFillLevel,gersteFillLevelPercent               = getFillLevelFoodFromId(3, husbandry)
           local sojaFillLevel,sojaFillLevelPercent                   = getFillLevelFoodFromId(7,husbandry)
           
           local rapsFillLevel,rapsFillLevelPercent                   = getFillLevelFoodFromId(5,husbandry)
           local sonnenblumenFillLevel,sonnenblumenFillLevelPercent   = getFillLevelFoodFromId(6,husbandry)
           
           local kartoFillLevel,kartoFillLevelPercent                 = getFillLevelFoodFromId(9,husbandry)
           local ruebenFillLevel,ruebenFillLevelPercent               = getFillLevelFoodFromId(10,husbandry)
          
           drawInfo("Schweine im Stall:", numberOfAnimals       ,"",  tonumber(linePadding));  
           drawInfo("Sauberkeit:"      , cleanlinessPercent    ,cleanlinessText, tonumber(linePadding)); 
           drawInfo("Wasser:"           , waterFillLevel        ,waterFillLevelPercent        ,tonumber(linePadding));
           drawInfo("Stroh:"            , strawFillLevel        ,strawFillLevelPercent        ,tonumber(linePadding));
           drawInfo("Mais:"             , maisFillLevel         ,maisFillLevelPercent         ,tonumber(linePadding));
           drawInfo("Weizen:"           , weizenFillLevel       ,weizenFillLevelPercent       ,tonumber(linePadding));
           drawInfo("Gerste:"           , gersteFillLevel       ,gersteFillLevelPercent       ,tonumber(linePadding));
           drawInfo("Soja:"             , sojaFillLevel         ,sojaFillLevelPercent         ,tonumber(linePadding));
           drawInfo("Raps:"             , rapsFillLevel         ,rapsFillLevelPercent         ,tonumber(linePadding));
           drawInfo("Sonnenblumen:"     , sonnenblumenFillLevel ,sonnenblumenFillLevelPercent ,tonumber(linePadding));
           drawInfo("Kartoffeln:"       , kartoFillLevel        ,kartoFillLevelPercent        ,tonumber(linePadding));
           drawInfo("Zuckerrüben:"      , ruebenFillLevel       ,ruebenFillLevelPercent        ,tonumber(linePadding));
          
           drawInfo("-KEY U-------------------------------------------------","","", tonumber(linePadding))
         else 
          
          drawInfo("Keine Schweine im Stall, kaufe welche","","", tonumber(linePadding))
          drawInfo("-KEY U-------------------------------------------------","","", tonumber(linePadding))
           end;
         end;
      paddingTop();
    end;
  end;
   if animalsHorseHudActive == true then -- HORSE
      for _,husbandry in pairs(g_currentMission.husbandries) do
			if husbandry.modulesByName.animals.animalType == "HORSE" then
      local numberOfAnimals = countAnimals(husbandry);
         if numberOfAnimals > 0 then
           
          local waterFillLevel,waterFillLevelPercent  = getFillLevelWaterFromId(18,husbandry)
          local strawFillLevel,strawFillLevelPercent  = getFillLevelStrawFromId(31,husbandry)
           
          local haferFillLevel,haferFillLevelPercent  = getFillLevelFoodFromId(4,husbandry)
          local heuFillLevel,heuFillLevelPercent      = getFillLevelFoodFromId(30,husbandry)
           
           drawInfo("Pferde im Stall:"  , numberOfAnimals ,"",                    tonumber(linePadding));     
           drawInfo("Wasser:"           , waterFillLevel  ,waterFillLevelPercent, tonumber(linePadding));
           drawInfo("Stroh:"            , strawFillLevel  ,strawFillLevelPercent, tonumber(linePadding));
           drawInfo("Hafer:"            , haferFillLevel  ,haferFillLevelPercent, tonumber(linePadding));
           drawInfo("Heu:"              , heuFillLevel    ,heuFillLevelPercent,   tonumber(linePadding));
          
           drawInfo("-KEY I-------------------------------------------------","","", tonumber(linePadding))
         else 
          
          drawInfo("Keine Pferde im Stall, kaufe welche","","", tonumber(linePadding))
          drawInfo("-KEY I-------------------------------------------------","","", tonumber(linePadding))
           end;
         end;
      paddingTop();
    end;
  end;
    if animalsSheepHudActive == true then -- SHEEP
      for _,husbandry in pairs(g_currentMission.husbandries) do
			if husbandry.modulesByName.animals.animalType == "SHEEP" then
         local numberOfAnimals = countAnimals(husbandry);
       
         if numberOfAnimals > 0 then
           
           local cleanliness = getCleanlinessFactorInPercent(husbandry);
           local cleanlinessPercent,cleanlinessText  = setCleanLinessColorIndicatorForMaxAndMinPercentValues(cleanliness)
           
            local waterFillLevel,waterFillLevelPercent             = getFillLevelWaterFromId(18,husbandry)
            local grassFillLevel,grassFillLevelPercent             = getFillLevelFoodFromId(28,husbandry)
            local heuFillLevel,heuFillLevelPercent                 = getFillLevelFoodFromId(30,husbandry)
           
           drawInfo("Schafe im Stall:"  , numberOfAnimals,"",                         tonumber(linePadding));  
           drawInfo("Sauberkeit:"       , cleanlinessPercent    ,cleanlinessText, tonumber(linePadding)); 
           drawInfo("Wasser:"           , waterFillLevel ,    waterFillLevelPercent,  tonumber(linePadding));
           drawInfo("Gras:"             , grassFillLevel ,    grassFillLevelPercent,  tonumber(linePadding));
           drawInfo("Heu:"              , heuFillLevel   ,    heuFillLevelPercent,    tonumber(linePadding));
          
           drawInfo("-KEY O-------------------------------------------------","","", tonumber(linePadding))
         else 
          
           drawInfo("Keine Schafe im Stall, kaufe welche","","", tonumber(linePadding))
          drawInfo("-KEY O-------------------------------------------------","","", tonumber(linePadding))
           end;
         end;
      paddingTop();
    end;
  end;
end;

